/*
 * Copyright (c) 1999 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * "Portions Copyright (c) 1999 Apple Computer, Inc.  All Rights
 * Reserved.  This file contains Original Code and/or Modifications of
 * Original Code as defined in and that are subject to the Apple Public
 * Source License Version 1.0 (the 'License').  You may not use this file
 * except in compliance with the License.  Please obtain a copy of the
 * License at http://www.apple.com/publicsource and read it before using
 * this file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License."
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
/* cb.h - critical-band pointers for use in atc.c 
 *
 * DO NOT EDIT - generated by cb.c
 */

/* Number of critical bands */
#define NCB 40

#ifndef ATCSOUND_VERSION
/* Low bin-number of each critical band */
static const int cbLo[] = {
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	8,
	9,
	10,
	11,
	12,
	14,
	16,
	18,
	20,
	22,
	25,
	28,
	31,
	35,
	39,
	44,
	49,
	55,
	62,
	70,
	79,
	89,
	100,
	112,
	125,
	139,
	154,
	170,
	187,
	205,
	224,
	244};

/* Width in bins of each critical band */
static const int cbWidth[] = {
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	2,
	2,
	2,
	2,
	2,
	3,
	3,
	3,
	4,
	4,
	5,
	5,
	6,
	7,
	8,
	9,
	10,
	11,
	12,
	13,
	14,
	15,
	16,
	17,
	18,
	19,
	20,
	13};
#endif !ATCSOUND_VERSION

/* Band centers assuming a 44.1 kHz sampling rate */
#ifndef LIBSYS_VERSION
static const float cbCentersHz[] = {
	     0.000,
	    86.133,
	   172.266,
	   258.398,
	   344.531,
	   430.664,
	   516.797,
	   602.930,
	   689.063,
	   775.195,
	   861.328,
	   947.461,
	  1076.660,
	  1248.926,
	  1421.191,
	  1593.457,
	  1765.723,
	  1981.055,
	  2239.453,
	  2497.852,
	  2799.316,
	  3143.848,
	  3531.445,
	  3962.109,
	  4435.840,
	  4995.703,
	  5641.699,
	  6373.828,
	  7192.090,
	  8096.484,
	  9087.012,
	 10163.672,
	 11326.465,
	 12575.391,
	 13910.449,
	 15331.641,
	 16838.965,
	 18432.422,
	 20112.012,
	 21533.203};

/* Band widths assuming a 44.1 kHz sampling rate */
static const float cbWidthsHz[] = {
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	    86.133,
	   172.266,
	   172.266,
	   172.266,
	   172.266,
	   172.266,
	   258.398,
	   258.398,
	   258.398,
	   344.531,
	   344.531,
	   430.664,
	   430.664,
	   516.797,
	   602.930,
	   689.063,
	   775.195,
	   861.328,
	   947.461,
	  1033.594,
	  1119.727,
	  1205.859,
	  1291.992,
	  1378.125,
	  1464.258,
	  1550.391,
	  1636.523,
	  1722.656,
	  1119.727};
#endif !LIBSYS_VERSION
